<template>
	<div class="product-list">
		<div class="card" v-for="product in products" :key="product.id">
			<p>{{ product.title }}</p>
			<img class="card-image" :src="product.image" alt="" />
			<p>Цена: {{ product.price }} {{ currency }}</p>
			<div>
				<input type="number" ref="amount" :id="product.id" />
				<span>кг</span>
			</div>
			<button @click="addToCart(product)">В корзину</button>
		</div>
	</div>
</template>

<script>
import { mapState, mapActions } from "vuex";

export default {
	computed: {
		...mapState(["products", "currency"]),
		// расчет отображения карточек с помощью метода
		// cardsWidth() {
		// 	let width = window.innerWidth;
		// 	if (width > 840) {
		// 		return this.products;
		// 	} else if (width > 420 && width < 840) {
		// 		return this.products.slice(0, 2);
		// 	}
		// 	return this.products.slice(0, 1);
		// },
	},
	methods: {
		...mapActions(["getProductsList"]),
		addToCart(product) {
			let amount = this.$refs.amount.find((input) => input.id === product.id).value;
			let data = {
				amount,
				price: product.price,
				title: product.title,
			};
			this.$store.commit("addToCart", data);
		},
	},
	mounted() {
		this.getProductsList();
	},
	created() {
		setInterval(this.getProductsList, 2000);
	},
};
</script>

<style scoped>
/* расчет отображения карточек с помощью медиа запросов */
@media (min-width: 420px) and (max-width: 840px) {
	.product-list {
		flex-wrap: wrap;
	}
	.card-image {
		width: 300px;
		height: 200px;
	}
}
@media (max-width: 420px) {
	.product-list {
		align-items: center;
		flex-direction: column;
	}
}
.product-list {
	padding: 10px;
	display: flex;
	justify-content: center;
}
.card {
	border: 1px solid #908888;
	border-radius: 5px;
	text-align: center;
	padding: 10px;
	margin: 15px;
}
.card-image {
	 max-width: 350px;
	max-height: 250px;
}
button {
	padding: 5px;
	margin: 5px;
}
</style>
